Index: dvblastctl.c
===================================================================
--- dvblastctl.c	(revision 45)
+++ dvblastctl.c	(working copy)
@@ -308,17 +308,23 @@
         PRINT_CAPS( CAN_BANDWIDTH_AUTO );
         PRINT_CAPS( CAN_GUARD_INTERVAL_AUTO );
         PRINT_CAPS( CAN_HIERARCHY_AUTO );
+#ifdef FE_CAN_8VSB
         PRINT_CAPS( CAN_8VSB );
         PRINT_CAPS( CAN_16VSB );
+#endif
 #if DVB_API_VERSION >= 5
         PRINT_CAPS( HAS_EXTENDED_CAPS );
-        /* FIXME: apparently this doesn't exist in some versions of the
-         * linux-dvb headers */
-        /* PRINT_CAPS( CAN_2G_MODULATION ); */
+#ifdef FE_CAN_2G_MODULATION
+        PRINT_CAPS( CAN_2G_MODULATION );
 #endif
+#endif
+#ifdef FE_NEEDS_BENDING
         PRINT_CAPS( NEEDS_BENDING );
+#endif
         PRINT_CAPS( CAN_MUTE_TS );
+#ifdef FE_CAN_RECOVER
         PRINT_CAPS( CAN_RECOVER );
+#endif
 #undef PRINT_CAPS
 
         printf("\nstatus:\n");
Index: dvb.c
===================================================================
--- dvb.c	(revision 45)
+++ dvb.c	(working copy)
@@ -374,7 +374,9 @@
 
     switch ( i_voltage )
     {
+#ifdef SEC_VOLTAGE_OFF
         case 0: fe_voltage = SEC_VOLTAGE_OFF; break;
+#endif
         default:
         case 13: fe_voltage = SEC_VOLTAGE_13; break;
         case 18: fe_voltage = SEC_VOLTAGE_18; break;
@@ -739,6 +741,7 @@
                  i_frequency, i_srate );
         break;
 
+#ifdef FE_ATSC
     case FE_ATSC:
         fep.frequency = i_frequency;
 
@@ -746,6 +749,7 @@
 
         msg_Dbg( NULL, "tuning ATSC frontend to f=%d", i_frequency );
         break;
+#endif
 
     default:
         msg_Err( NULL, "unknown frontend type %d", info.type );
Index: demux.c
===================================================================
--- demux.c	(revision 45)
+++ demux.c	(working copy)
@@ -749,6 +749,8 @@
     {
         if ( pp_outputs[i]->i_maddr && pp_outputs[i]->i_sid == i_sid )
         {
+            block_t *p_block;
+
             if( b_unique_tsid )
             {
                 p_section->p_data[8]  = (pp_outputs[i]->i_ts_id >> 8) & 0xff;
@@ -757,8 +759,6 @@
 
             dvbpsi_BuildPSISection( p_section );
 
-            block_t *p_block;
-
             p_block = WritePSISection( p_section,
                                        EIT_PID,
                                        &pp_outputs[i]->i_eit_cc );
Index: en50221.c
===================================================================
--- en50221.c	(revision 45)
+++ en50221.c	(working copy)
@@ -37,6 +37,7 @@
 #include <arpa/inet.h>
 #include <poll.h>
 #include <errno.h>
+#include <time.h>
 
 /* DVB Card Drivers */
 #include <linux/dvb/version.h>
@@ -1961,6 +1962,7 @@
     {
         struct ca_slot_info info;
         system_ids_t *p_ids;
+        ca_msg_t ca_msg;
         info.num = 0;
 
         /* We don't reset the CAM in that case because it's done by the
@@ -1991,7 +1993,6 @@
 
         /* Get application info to find out which cam we are using and make
            sure everything is ready to play */
-        ca_msg_t ca_msg;
         ca_msg.length=3;
         ca_msg.msg[0] = ( AOT_APPLICATION_INFO & 0xFF0000 ) >> 16;
         ca_msg.msg[1] = ( AOT_APPLICATION_INFO & 0x00FF00 ) >> 8;
